



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>shell脚本监控Linux系统性能指标</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">shell脚本监控Linux系统性能指标</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 04:05:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>2016-11-04 22:41 原作者不详<br /><br />
分类： Linux（7）<br /><br />
在服务器运维过程中，经常需要对服务器的各种资源进行监控，<br /><br />
例如：CPU的负载监控，磁盘的使用率监控，进程数目监控等等，以在系统出现异常时及时报警，通知系统管理员。<br /><br />
本文介绍在Linux系统下几种常见的监控需求及其shell脚本的编写。</p>
<p>文章目录：</p>
<p>1.Linux使用 Shell 检查进程是否存在</p>
<p>2.Linux使用 Shell检测进程 CPU 利用率</p>
<p>3.Linux使用 Shell检测进程 内存使用量</p>
<pre class="prettyprint linenums"><code>4.Linux使用 Shell检测进程 句柄使用量

5.Linux使用 Shell查看某个 TCP 或 UDP 端口是否在监听<br />
</code></pre>
<p>6.Linux使用 Shell查看某个进程名正在运行的个数</p>
<p>7.Linux使用 Shell检测系统 CPU 负载</p>
<p>8.Linux使用 Shell检测系统磁盘空间</p>
<p>9.总结</p>
<p>检查进程是否存在</p>
<p>在对进程进行监控时，我们一般需要得到该进程的 ID，进程 ID 是进程的唯一标识，但是有时可能在服务器上不同用户下运行着多个相同进程名的进程，<br /><br />
下面的函数 GetPID 给出了获取指定用户下指定进程名的进程 ID 功能（目前只考虑这个用户下启动一个此进程名的进程），它有两个参数为用户名和进程名，它首先使用 ps 查找进程信息，同时通过 grep 过滤出需要的进程，最后通过 sed 和 awk 查找需要进程的 ID 值（此函数可根据实际情况修改，比如需要过滤其它信息等）。</p>
<p>清单 1. 对进程进行监控</p>
<p>function GetPID #User #Name<br /><br />
{<br /><br />
PsUser=$1<br /><br />
PsName=$2<br /><br />
pid=<code>ps -u $PsUser|grep $PsName|grep -v grep|grep -v vi|grep -v dbx\n      |grep -v tail|grep -v start|grep -v stop |sed -n 1p |awk '{print $1}'</code><br /><br />
echo $pid<br /><br />
}<br /><br />
示例演示：</p>
<p>1）源程序（例如查找用户为 root，进程名为 CFTestApp 的进程 ID）</p>
<p>PID=<code>GetPID root CFTestApp</code></p>
<pre class="prettyprint linenums"><code>echo $PID<br />
</code></pre>
<p>2）结果输出</p>
<p>11426</p>
<p>3）结果分析</p>
<p>从上面的输出可见：11426 为 root 用户下的 CFTestApp 程序的进程 ID。</p>
<p>4）命令介绍</p>
<ol><li>ps: 查看系统中瞬间进程信息。 参数：-u&lt; 用户识别码 &gt; 列出属于该用户的程序的状况，也可使用用户名称来指定。 -p&lt; 进程识别码 &gt; 指定进程识别码，并列出该进程的状况。 -o 指定输出格式 2. grep: 用于查找文件中符合字符串的当前行。 参数：-v 反向选择，亦即显示出没有 ‘搜寻字符串’ 内容的那一行。 3. sed: 一个非交互性文本编辑器，它编辑文件或标准输入导出的文件，一次只能处理一行内容。 参数：-n 读取下一个输入行，用下一个命令处理新的行而不是用第一个命令。 p 标志 打印匹配行 4. awk：一种编程语言，用于在 linux/unix 下对文本和数据进行处理。数据可以来自标准输入、一个或多个文件，或其它命令的输出。它支持用户自定义函数和动态正则表达式等先进功能，是 linux/unix 下的一个强大编程工具。它在命令行中使用，但更多是作为脚本来使用。awk 的处理文本和数据的方式：它逐行扫描文件，从第一行到最后一行，寻找匹配的特定模式的行，并在这些行上进行你想要的操作。如果没有指定处理动作，则把匹配的行显示到标准输出 ( 屏幕 )，如果没有指定模式，则所有被操作所指定的行都被处理。 参数：-F fs or –field-separator fs ：指定输入文件折分隔符，fs 是一个字符串或者是一个正则表达式，如 -F:。</li></ol>
<p>有时有可能进程没有启动，下面的功能是检查进程 ID 是否存在，如果此进程没有运行输出：</p>
<p>The process does not exist.<br /><br />
# 检查进程是否存在<br /><br />
if [ &quot;-$PID&quot; == &quot;-&quot; ]<br /><br />
then<br /><br />
{<br /><br />
echo &quot;The process does not exist.&quot;<br /><br />
}<br /><br />
fi<br /><br />
检测进程 CPU 利用率</p>
<p>在对应用服务进行维护时，我们经常遇到由于 CPU 过高导致业务阻塞，造成业务中断的情况。CPU 过高可能由于业务量过负荷或者出现死循环等异常情况，通过脚本对业务进程 CPU 进行时时监控，可以在 CPU 利用率异常时及时通知维护人员，便于维护人员及时分析，定位，以及避免业务中断等。下面的函数可获得指定进程 ID 的进程 CPU 利用率。它有一个参数为进程 ID，它首先使用 ps 查找进程信息，同时通过 grep -v 过滤掉 %CPU 行，最后通过 awk 查找 CPU 利用百分比的整数部分（如果系统中有多个 CPU，CPU 利用率可以超过 100%）。</p>
<p>清单 2. 对业务进程 CPU 进行实时监控</p>
<p>function GetCpu<br /><br />
{<br /><br />
CpuValue=<code>ps -p $1 -o pcpu |grep -v CPU | awk '{print $1}' | awk -  F. '{print $1}'</code><br /><br />
echo $CpuValue<br /><br />
}<br /><br />
下面的功能是通过上面的函数 GetCpu 获得此进程的 CPU 利用率，然后通过条件语句判断 CPU 利用率是否超过限制，如果超过 80%（可以根据实际情况进行调整），则输出告警，否则输出正常信息。</p>
<p>清单 3. 判断 CPU 利用率是否超过限制</p>
<p>function CheckCpu<br /><br />
{<br /><br />
PID=$1<br /><br />
cpu=<code>GetCpu $PID</code><br /><br />
if [ $cpu -gt 80 ]<br /><br />
then<br /><br />
{<br /><br />
echo “The usage of cpu is larger than 80%”<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo “The usage of cpu is normal”<br /><br />
}<br /><br />
fi<br /><br />
}<br /><br />
示例演示：</p>
<p>1）源程序（假设上面已经查询出 CFTestApp 的进程 ID 为 11426）</p>
<p>CheckCpu 11426<br /><br />
2）结果输出</p>
<p>The usage of cpu is 75<br /><br />
The usage of cpu is normal</p>
<p>3）结果分析</p>
<p>从上面的输出可见：CFTestApp 程序当前的 CPU 使用为 75%，是正常的，没有超过 80% 的告警限制。</p>
<p>检测进程内存使用量</p>
<p>在对应用服务进行维护时，也经常遇到由于内存使用过大导致进程崩溃，造成业务中断的情况（例如 32 位程序可寻址的最大内存空间为 4G，如果超出将申请内存失败，同时物理内存也是有限的）。内存使用过高可能由于内存泄露，消息堆积等情况，通过脚本对业务进程内存使用量进行时时监控，可以在内存使用量异常时及时发送告警（例如通过短信），便于维护人员及时处理。下面的函数可获得指定进程 ID 的进程内存使用情况。它有一个参数为进程 ID，它首先使用 ps 查找进程信息，同时通过 grep -v 过滤掉 VSZ 行 , 然后通过除 1000 取以兆为单位的内存使用量。</p>
<p>清单 4. 对业务进程内存使用量进行监控</p>
<p>function GetMem<br /><br />
{<br /><br />
MEMUsage=<code>ps -o vsz -p $1|grep -v VSZ</code><br /><br />
(( MEMUsage /= 1000))<br /><br />
echo $MEMUsage<br /><br />
}<br /><br />
下面的功能是通过上面的函数 GetMem 获得此进程的内存使用，然后通过条件语句判断内存使用是否超过限制，如果超过 1.6G（可以根据实际情况进行调整），则输出告警，否则输出正常信息。</p>
<p>清单 5. 判断内存使用是否超过限制</p>
<p>mem=<code>GetMem $PID</code><br /><br />
if [ $mem -gt 1600 ]<br /><br />
then<br /><br />
{<br /><br />
echo “The usage of memory is larger than 1.6G”<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo “The usage of memory is normal”<br /><br />
}<br /><br />
fi<br /><br />
示例演示：</p>
<p>1）源程序（假设上面已经查询出 CFTestApp 的进程 ID 为 11426）</p>
<p>mem=<code>GetMem 11426</code></p>
<pre class="prettyprint linenums"><code>echo &quot;The usage of memory is $mem M&quot;

if [ $mem -gt 1600 ]<br />
then<br />
{<br />
     echo &quot;The usage of memory is larger than 1.6G&quot;<br />
}<br />
else<br />
{<br />
    echo &quot;The usage of memory is normal&quot;<br />
}<br />
fi<br />
</code></pre>
<p>2）结果输出</p>
<p>The usage of memory is 248 M<br /><br />
The usage of memory is normal</p>
<p>3）结果分析</p>
<p>从上面的输出可见：CFTestApp 程序当前的内存使用为 248M，是正常的，没有超过 1.6G 的告警限制。</p>
<p>检测进程句柄使用量</p>
<p>在对应用服务进行维护时，也经常遇到由于句柄使用 过量导致业务中断的情况。每个平台对进程的句柄使用都是有限的，例如在 Linux 平台，我们可以使用 ulimit – n 命令（open files (-n) 1024）或者对 /etc/security/limits.conf 的内容进行查看，得到进程句柄限制。句柄使用过高可能由于负载过高，句柄泄露等情况，通过脚本对业务进程句柄使用量进行时时监控，可以在异常时及时发送告警（例如通过短信），便于维护人员及时处理。下面的函数可获得指定进程 ID 的进程句柄使用情况。它有一个参数为进程 ID，它首先使用 ls 输出进程句柄信息，然后通过 wc -l 统计输出句柄个数。</p>
<p>function GetDes<br /><br />
{<br /><br />
DES=<code>ls /proc/$1/fd | wc -l</code><br /><br />
echo $DES<br /><br />
}<br /><br />
下面功能是通过上面的函数 GetDes 获得此进程的句柄使用量，然后通过条件语句判断句柄使用是否超过限制，如果超过 900（可以根据实际情况进行调整）个，则输出告警，否则输出正常信息。</p>
<p>des=<code> GetDes $PID</code><br /><br />
if [ $des -gt 900 ]<br /><br />
then<br /><br />
{<br /><br />
echo “The number of des is larger than 900”<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo “The number of des is normal”<br /><br />
}<br /><br />
fi<br /><br />
示例演示：</p>
<p>1）源程序（假设上面查询出 CFTestApp 的进程 ID 为 11426）</p>
<p>des=<code>GetDes 11426</code></p>
<pre class="prettyprint linenums"><code>echo &quot;The number of des is $des&quot;

if [ $des -gt 900 ]<br />
then<br />
{<br />
     echo &quot;The number of des is larger than 900&quot;<br />
}<br />
else<br />
{<br />
    echo &quot;The number of des is normal&quot;<br />
}<br />
fi<br />
</code></pre>
<p>2）结果输出</p>
<p>The number of des is 528<br /><br />
The number of des is normal</p>
<p>3）结果分析</p>
<p>从上面的输出可见：CFTestApp 程序当前的句柄使用为 528 个，是正常的，没有超过 900 个的告警限制。</p>
<p>4）命令介绍</p>
<p>wc: 统计指定文件中的字节数、字数、行数 , 并将统计结果显示输出。 参数：-l 统计行数。 -c 统计字节数。 -w 统计字数。</p>
<p>查看某个 TCP 或 UDP 端口是否在监听</p>
<p>端口检测是系统资源检测经常遇到的，特别是在网络通讯情况下，端口状态的检测往往是很重要的。有时可能进程，CPU，内存等处于正常状态，但是端口处于异常状态，业务也是没有正常运行。下面函数可判断指定端口是否在监听。它有一个参数为待检测端口，它首先使用 netstat 输出端口占用信息，然后通过 grep, awk,wc 过滤输出监听 TCP 端口的个数，第二条语句为输出 UDP 端口的监听个数，如果 TCP 与 UDP 端口监听都为 0，返回 0，否则返回 1.</p>
<p>清单 6. 端口检测</p>
<p>function Listening<br /><br />
{<br /><br />
TCPListeningnum=<code>netstat -an | grep &quot;:$1 &quot; | \n     awk '$1 == &quot;tcp&quot; &amp;&amp; $NF == &quot;LISTEN&quot; {print $0}' | wc -l</code><br /><br />
UDPListeningnum=<code>netstat -an|grep &quot;:$1 &quot; \n     |awk '$1 == &quot;udp&quot; &amp;&amp; $NF == &quot;0.0.0.0:*&quot; {print $0}' | wc -l</code><br /><br />
(( Listeningnum = TCPListeningnum + UDPListeningnum ))<br /><br />
if [ $Listeningnum == 0 ]<br /><br />
then<br /><br />
{<br /><br />
echo &quot;0&quot;<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo &quot;1&quot;<br /><br />
}<br /><br />
fi<br /><br />
}<br /><br />
示例演示：</p>
<p>1）源程序（例如查询 8080 端口的状态是否在监听）</p>
<p>isListen=<code>Listening 8080</code><br /><br />
if [ $isListen -eq 1 ]<br /><br />
then<br /><br />
{<br /><br />
echo &quot;The port is listening&quot;<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo &quot;The port is not listening&quot;<br /><br />
}<br /><br />
fi<br /><br />
2）结果输出</p>
<p>The port is listening</p>
<p>3）结果分析</p>
<p>从上面的输出可见：这个 Linux 服务器的 8080 端口处在监听状态。</p>
<p>4）命令介绍</p>
<p>netstat: 用于显示与 IP、TCP、UDP 和 ICMP 协议相关的统计数据，一般用于检验本机各端口的网络连接情况。 参数：-a 显示所有连线中的 Socket。 -n 直接使用 IP 地址，而不通过域名服务器。</p>
<p>下面的功能也是检测某个 TCP 或者 UDP 端口是否处在正常状态。</p>
<p>tcp: netstat -an|egrep $1 |awk '$6 == &quot;LISTEN&quot; &amp;&amp; $1 == &quot;tcp&quot; {print $0}' udp: netstat -an|egrep $1 |awk '$1 == &quot;udp&quot; &amp;&amp; $5 == &quot;0.0.0.0:*&quot; {print $0}'<br /><br />
命令介绍</p>
<p>egrep: 在文件内查找指定的字符串。egrep 执行效果如 grep -E，使用的语法及参数可参照 grep 指令，与 grep 不同点在于解读字符串的方法，egrep 是用扩展的正则表达式语法来解读，而 grep 则用基本的正则表达式语法，扩展的正则表达式比基本的正则表达式有更完整的表达规范。</p>
<p>查看某个进程名正在运行的个数</p>
<p>有时我们可能需要得到服务器上某个进程的启动个数，下面的功能是检测某个进程正在运行的个数，例如进程名为 CFTestApp。</p>
<p>Runnum=`ps -ef | grep -v vi | grep -v tail | grep &quot;[ /]CFTestApp&quot; | grep -v grep | wc -l<br /><br />
检测系统 CPU 负载</p>
<p>在对服务器进行维护时，有时也遇到由于系统 CPU（利用率）负载 过量导致业务中断的情况。服务器上可能运行多个进程，查看单个进程的 CPU 都是正常的，但是整个系统的 CPU 负载可能是异常的。通过脚本对系统 CPU 负载进行时时监控，可以在异常时及时发送告警，便于维护人员及时处理，预防事故发生。下面的函数可以检测系统 CPU 使用情况 . 使用 vmstat 取 5 次系统 CPU 的 idle 值，取平均值，然后通过与 100 取差得到当前 CPU 的实际占用值。</p>
<p>function GetSysCPU<br /><br />
{<br /><br />
CpuIdle=<code>vmstat 1 5 |sed -n '3,$p' \n    |awk '{x = x + $15} END {print x/5}' |awk -F. '{print $1}'    CpuNum=</code>echo &quot;100-$CpuIdle&quot; | bc`<br /><br />
echo $CpuNum<br /><br />
}<br /><br />
示例演示：</p>
<p>1）源程序</p>
<p>cpu=<code>GetSysCPU</code></p>
<p>echo &quot;The system CPU is $cpu&quot;</p>
<p>if [ $cpu -gt 90 ]<br /><br />
then<br /><br />
{<br /><br />
echo &quot;The usage of system cpu is larger than 90%&quot;<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo &quot;The usage of system cpu is normal&quot;<br /><br />
}<br /><br />
fi<br /><br />
2）结果输出</p>
<p>The system CPU is 87<br /><br />
The usage of system cpu is normal</p>
<p>3）结果分析</p>
<p>从上面的输出可见：当前 Linux 服务器系统 CPU 利用率为 87%，是正常的，没有超过 90% 的告警限制。</p>
<p>4）命令介绍</p>
<p>vmstat：Virtual Meomory Statistics（虚拟内存统计）的缩写，可对操作系统的虚拟内存、进程、CPU 活动进行监视。参数： -n 表示在周期性循环输出时，输出的头部信息仅显示一次。</p>
<p>检测系统磁盘空间</p>
<p>系统磁盘空间检测是系统资源检测的重要部分，在系统维护维护中，我们经常需要查看服务器磁盘空间使用情况。因为有些业务要时时写话单，日志，或者临时文件等，如果磁盘空间用尽，也可能会导致业务中断，下面的函数可以检测当前系统磁盘空间中某个目录的磁盘空间使用情况 . 输入参数为需要检测的目录名，使用 df 输出系统磁盘空间使用信息，然后通过 grep 和 awk 过滤得到某个目录的磁盘空间使用百分比。</p>
<p>function GetDiskSpc<br /><br />
{<br /><br />
if [ $# -ne 1 ]<br /><br />
then<br /><br />
return 1<br /><br />
fi</p>
<pre class="prettyprint linenums"><code>Folder=&quot;$1$&quot;<br />
DiskSpace=`df -k |grep $Folder |awk '{print $5}' |awk -F% '{print $1}'<br />
echo $DiskSpace<br />
</code></pre>
<p>}<br /><br />
示例演示：</p>
<p>1）源程序（检测目录为 /boot）</p>
<p>Folder=&quot;/boot&quot;</p>
<p>DiskSpace=<code>GetDiskSpc $Folder</code></p>
<p>echo &quot;The system $Folder disk space is $DiskSpace%&quot;</p>
<p>if [ $DiskSpace -gt 90 ]<br /><br />
then<br /><br />
{<br /><br />
echo &quot;The usage of system disk($Folder) is larger than 90%&quot;<br /><br />
}<br /><br />
else<br /><br />
{<br /><br />
echo &quot;The usage of system disk($Folder)  is normal&quot;<br /><br />
}<br /><br />
fi<br /><br />
2）结果输出</p>
<p>The system /boot disk space is 14%<br /><br />
The usage of system disk(/boot)  is normal</p>
<p>3）结果分析</p>
<p>从上面的输出可见：当前此 Linux 服务器系统上 /boot 目录的磁盘空间已经使用了 14%，是正常的，没有超过使用 90% 的告警限制。</p>
<p>4）命令介绍</p>
<p>df：检查文件系统的磁盘空间占用情况。可以利用该命令来获取硬盘被占用了多少空间，目前还剩下多少空间等信息。 参数：-k 以 k 字节为单位显示。</p>
<p>总结</p>
<p>在 Linux 平台下，shell 脚本监控是一个非常简单，方便，有效的对服务器，进程进行监控的方法，对系统开发以及进程维护人员非常有帮助。它不仅可以对上面的信息进行监控，发送告警，同时也可以监控进程的日志等等的信息，希望本文对大家有帮助。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rp5d80.html">Python标准模块--concurrent&period;futures</a>
		</li>
						<li><a href="https://www.batexi.com/a/390po3n8.html">HBase最佳实践－列族设计优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvw1lz9.html">emmet常用的输入</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1g5v2q.html">GTX 680 Kepler</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnlwz9.html">flash视频器播放器代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yyppeq.html">MYSQL中的SELECT查询时进行运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnrdjq.html">Xcode6新建的工程没有Frameworks文件夹了&quest;&excl;原来是这样</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ox7zn9.html">前端MVVM学习之KnockOut&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wo6ylq.html">C&sol;C&plus;&plus;中经常使用的字符串处理函数和内存字符串函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4znj009.html">Ansible详解（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvde09.html">Wamp之mysql密码故事</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdvd09.html">POJ 1308 Is It A Tree&quest; 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jjjzq.html">1st&lowbar;homework&lowbar;SE--四则运算题目生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojr3e5q.html">MacOS下postgresql数据库密码的那些事</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prj3y8.html">Jmeter运行后出现乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpne10q.html">VIVO 手机重力传感器踩坑记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16onyq.html">java虚拟机的类加载器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g2exq.html">Python数据分析基础PDF</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jxlz9.html">&lbrack;HNOI2012&rsqb;射箭&lpar;计算几何）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6e1eq.html">LoadRunner 11安装Micosoft Visual C&plus;&plus; 2005 SP1时提示命令行选项语法错误</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8koz0r3q.html">ajax跨域终极解决办法！</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpyme79.html">java使用poi解析或处理excel的时候，如何防止数字变成科学计数法的形式和其他常见Excel中数据转换问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emk13j9.html">postgresql模式创建、修改、删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm7mxg9.html">Monkey Tradition---LightOj1319（中国剩余定理模板）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2god08.html">iOS邮箱、手机号等常用验证功能 判断字符串是否int float</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm7p6g9.html">marathon-lb-什么是服务发现？&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9531j2v8.html">PAT 1110 Complete Binary Tree&lbrack;判断完全二叉树&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql10kxx9.html">java基础知识面试题&lpar;41-95&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e1gke9.html">3&period;5 Templates -- Binding Element Attributes&lpar;绑定元素属性&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kozke7q.html">Java实现二叉查找树</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
